/*
 * button.c
 *
 *  Created on: 08.09.2016
 *      Author: dehottgw
 */


#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>

#include "button.h"
#include "gpio.h"


const uint32_t BUTTON_CYCLE = 10;
const uint8_t ACTIVE_STATE_CNT_REQUIRED = 5;

tPin buttonPins[BUTTONS_END] = { BUTTON_1 };

typedef struct {
  void (*action)(void *);
  void *actionArg;
  uint8_t activeStateCnt;
} tButtonHandle;


tButtonHandle buttonHandles[BUTTONS_END];



void buttonInit(void *handleArg) {
  for (tButton b = BUTTONS_FIRST; b < BUTTONS_END; b++) {
    buttonHandles[b].action = NULL;
    buttonHandles[b].actionArg = NULL;
    buttonHandles[b].activeStateCnt = 0;
  }
}

void buttonExec(void *handleArg) {
  for (tButton b = BUTTONS_FIRST; b < BUTTONS_END; b++) {
    if (buttonHandles[b].action != NULL) {
      if (gpioGetPin(buttonPins[b]) == LOW) {
        buttonHandles[b].activeStateCnt++;
        if (buttonHandles[b].activeStateCnt > ACTIVE_STATE_CNT_REQUIRED) {
          buttonHandles[b].action(buttonHandles[b].actionArg);
          buttonHandles[b].activeStateCnt = 0;
        }
      }
    }
  }
}

void buttonRegister(void (*action)(void *), void *actionArg, tButton button) {
  buttonHandles[button].action = action;
  buttonHandles[button].actionArg  = actionArg;
  buttonHandles[button].activeStateCnt = 0;
}

